#define _USE_MATH_DEFINES
#include <bits/stdc++.h>
using namespace std;
using ul = unsigned long long;
using ll = long long;
using ld = long double;
using pll = pair<ll,ll>;
#define in(v,c) ((c).find(v) != (c).end())
#define F(i,n) for(ll i = 0; i < (ll)(n); i++)
#define Fun(i,n) for(ul i = ; i < (n); i++)
#ifdef GPD
template<class F>void lerr(F&&f){cerr<<forward<F>(f)<<endl;}
template<class F,class...R>void lerr(F&&f,R&&...r){cerr<<forward<F>(f)<<' ';lerr(forward<R>(r)...);}
#else
#define lerr(...)
#endif


vector<ll> primesgen(ll lim = 1e6)
{
    vector<bool> isPrime(lim, true);
    isPrime[0] = isPrime[1] = false;
    for(ll i = 4; i < (ll)isPrime.size(); i+=2)
        isPrime[i] = false;

    for(ll i = 3; i*i < (ll)isPrime.size(); i+=2)
    {
        if(!isPrime[i]) continue;
        for(ll j = i+i; j < (ll)isPrime.size(); j += i)
            isPrime[j] = false;
    }

    vector<ll> ret;
    F(i, isPrime.size())
    {
        if(isPrime[i])
            ret.push_back(i);
    }

    return ret;

}

ll p;
vector<ll> primes;

vector<vector<ll>> dp;
const ll undef = -1;


ll solve(ll prev, ll cur)
{
    if(cur == (ll)primes.size() -1)
        return (primes[cur] - primes[prev]) <= 14; 
    
    if(primes[cur] - primes[prev] > 14)
        return 0;
    
    if(dp[prev][cur] != undef)
        return dp[prev][cur];
    


    ll ret = solve(prev, cur + 1) + solve(cur, cur + 1);

    return dp[prev][cur] = ret;

}

int main(int argc, char const *argv[]) {
    cin.tie(0)->sync_with_stdio(0); cin.exceptions(cin.failbit);
    cout << setprecision(9) << fixed; lerr("ready");


    cin >> p;

    if(p == 1){
        cout << 1 << endl;
        return 0;
    }
    else if(p == 2)
    {
        cout << 1 << endl;
        return 0;
    }

    primes = primesgen(p);
    if(primes.empty() || primes.back() != p)
        primes.push_back(p);
    
    dp = vector<vector<ll>>(primes.size()+7, vector<ll>(primes.size()+7, undef));
    cout << solve(0, 1) << endl;

    return 0;
}